Status: Resolved Priority: Must have
Author: Peter Niederlag Category: Fluid
Created: 2011-12-14 Assigned To:
Updated: 2015-06-16 Due date:
TYPO3 Version: 6.2
PHP Version:
Complexity:
Is Regression: No
Sprint Focus:
Subject: imageViewHelper should not throw exception
Description

Hey guys,

we don't like the imageViewHelper to throw exceptions if an image is not found. it should behave like the underlying
cObj::getImgResource() and just don't do anything.

regards, foertel, pniederlag

Related issues:
related to TYPO3.Fluid - Bug # 30935: Catch ViewHelper exceptions and log the... Resolved 2011-10-14

Associated revisions
Revision a3e48b1b - 2015-06-16 17:20 - Helmut Hummel

[BUGFIX] ViewHelper Exceptions are logged in Production

In Production context all Exceptions from ViewHelpers
will be silently logged.
Additionally, the output is discarded from rendering.
In Development they will be re-thrown, so the
global exception handler will be triggered.

Resolves: #32528
Releases: master
Change-Id: I4af4d03ff6048fcc8999f4a48d5c2897dc43fc4e
Reviewed-on: http://review.typo3.org/40212
Reviewed-by: Nicole Cordes <typo3@cordes.co>
Tested-by: Nicole Cordes <typo3@cordes.co>
Reviewed-by: Peter Niederlag <peter.niederlag@typo3.org>
Reviewed-by: Wouter Wolters <typo3@wouterwolters.nl>
Tested-by: Wouter Wolters <typo3@wouterwolters.nl>

History
#1 - 2013-01-02 13:37 - Anja Leichsenring
- Project changed from Extbase MVC Framework to Fluid
- Category changed from 963 to Fluid: ViewHelpers

#2 - 2014-09-11 15:49 - Alexander Opitz
- Status changed from New to Needs Feedback

Hi,

was this issue fixed or does it still exists?

#3 - 2014-10-30 12:53 - Riccardo De Contardi

It still exists in TYPO3 6.2.6

Test:
1. upload the image 539.png into /fileadmin/Images/
2. add somewhere in the page template /partial: <f:image src="fileadmin/Images/539.png" />
3. the image is shown
4. delete the image
5. refresh page - the following error is shown:

Oops, an error occurred!

File /Images/539.png/ does not exist.

More information regarding this error might be available online.

#4 - 2014-11-03 15:37 - Alexander Opitz
- Project changed from Fluid to Core
- Category changed from Fluid: ViewHelpers to Fluid
- TYPO3 Version set to 6.2
- Is Regression set to No

#5 - 2014-12-08 15:10 - Alexander Opitz
- Status changed from Needs Feedback to New

#6 - 2015-03-02 13:43 - Christian Weiske

If someone implements this, it would be nice to have the option what to do when the image cannot be found:

    1. Output no image tag
    2. Output an image tag with a "broken" image whose path can be customized, maybe via an attribute
    3. Throw exception

#7 - 2015-03-02 15:32 - Michael Münch

The Viewhelper should never throw any exceptions for invalid or non existing files cause this is not an breaking error which could result in invalid code
execution.
Instead log the error to the system log and just output an empty string or dummy image so developers can track the error and customers / users can
use the page as it is instead of seeing an "Oops an error occured".

While exceptions are fine during development and to protect pieces of the core from running into undefined states - they are not meant to be used as
simple hints to the end user of the website.

If someone can link me some instructions on how to create an patch - i'll try to share our "Bugfix" which we added to our core which simply adds an try
/ catch Block around some pieces und catch the exception for further processing.

#8 - 2015-06-12 21:56 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/40212

#9 - 2015-06-12 21:57 - Gerrit Code Review

Patch set 3 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/40212

#10 - 2015-06-12 23:06 - Gerrit Code Review

Patch set 4 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/40212

#11 - 2015-06-16 09:48 - Gerrit Code Review

Patch set 5 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/40212

#12 - 2015-06-16 17:31 - Helmut Hummel
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:a3e48b1b368db95df08f852c17f928184da83724.
